require 'fileutils'
require 'open-uri'
require 'digest/md5'

require "fourteeninch/version"
require "fourteeninch/client"
require "fourteeninch/screens"
require "fourteeninch/auth"
require "fourteeninch/core"
require "fourteeninch/main_menu"
require "fourteeninch/customers"


module Fourteeninch

  @api_base = 'https://api.fourteeninch.com/api/v1'

  class << self
    attr_accessor :api_key, :api_secret, :api_base
  end

  def self.api_url(url='')
    "#{@api_base}/#{url}"
  end


  def self.settings_file
    File.expand_path('~/.fourteeninch')
  end

  def self.load_settings
    if File.exist?(self.settings_file)
      config = File.open(self.settings_file) do|file|
        Marshal.load(file)
      end
      self.api_key = config[:api_key] if config.has_key?(:api_key)
      self.api_secret = config[:api_secret] if config.has_key?(:api_secret)
    end
  end
end
